﻿
package {
	import flash.display.MovieClip;
	import flash.net.NetConnection;
	import flash.net.SharedObject;	
	import flash.utils.Timer;
	import flash.events.*;
	import flash.text.TextField;
	
	import flash.net.Responder;

	public class UniqueControl extends MovieClip {
		
		private var myLO:SharedObject; // local object to store id
		private var so:SharedObject;		
		private var nc:NetConnection;
			
		private var myApp:String; // the name of your application
		private var myModulus:Number; // how many players do you want together
		private var myPersistence:Boolean; // if the players data is stored when closed
		private var myFill:Boolean; // if a new player takes the place of a player who has left
		
		private var myID:Number;		
		private var myTimer:Timer = new Timer(1000,1);
		
		public var error:Boolean = true;
		private var addedCheck:Boolean = false;
		private var idList:Array = new Array();
		private var actingList:Array = new Array();
		private var lastList:Array = new Array();
		private var lastTheirData:Object = new Object();
		
		private var myNum:Number = 0;
		private var myActingNum:Number = 0;		
		private var whichList:Number = 1;
		
		private var myMessage:TextField;
		
		private var myResponder:Responder = new Responder(onReply);		
			
		public function UniqueControl(theApp:String, theModulus:Number=100000, thePersistence:Boolean=false, theFill:Boolean=false, theMessage:TextField=null) {
										
			myMessage = theMessage;								
			myApp = theApp;
			myModulus = (theModulus!=0)?theModulus:100000;			
			myPersistence = thePersistence;
			myFill = theFill;
			
			if (myPersistence) { // can't run multiple browsers on the same computer
				myLO = SharedObject.getLocal("uniquecontrol");
				if (!myLO.data.id) {
					myLO.data.id = Math.floor(Math.random()*1000000);
				}
				myID = myLO.data.id;			
			} else { // browsers on the same computer will operate different elements
				myID = Math.floor(Math.random()*1000000);
			}
			
			nc=new NetConnection();
			nc.addEventListener(NetStatusEvent.NET_STATUS,netStatusHandler);
			nc.connect("rtmp://localhost/uniquecontrol/", myApp, myPersistence, myID);
			
		}

		public function netStatusHandler(event:NetStatusEvent) {
			
			if (event.info.code == "NetConnection.Connect.Success") { 
				myTimer.addEventListener(TimerEvent.TIMER, sendConnect);
				myTimer.start();
				so = SharedObject.getRemote("others_" + myApp, nc.uri, myPersistence);
				so.connect(nc);					
			} else {
				error = true;
				dispatchEvent(new Event(Event.CONNECT));			
			}
		}
		
		private function sendConnect(e:TimerEvent) {		
			error = false;					
			// add to master id list and get number in that list
			if (so.data.idList == undefined) { // if there is no list then add us and save the list			
				idList.push(myID);
				so.setProperty("idList", idList);
				so.setDirty("idList");
				so.setProperty("id_"+myID, new Object());
				so.setDirty("id_"+myID);
			} else { 	
				idList = so.data.idList;					
				myNum = idList.indexOf(myID);
				// if we are not in the list add us
				if (myNum == -1) {
					if (myFill) {
						var mySpot:Number = idList.indexOf(null);
						if (mySpot == -1) {
							idList.push(myID);			
						} else {
							idList[mySpot] = myID;
						}
					} else {
						idList.push(myID);
					}
					so.setProperty("idList", idList);
					so.setDirty("idList");
					myNum = idList.indexOf(myID);
					so.setProperty("id_"+myID, new Object());	
					so.setDirty("id_"+myID);
				}
			}
			// figure out based on the modulus our acting list and store for removal		
			whichList = Math.ceil((myNum + .00001) / myModulus);
			if (so.data.lookUp) {
				var lookUp = so.data.lookUp;	
				lookUp[myNum] = whichList;
				so.setProperty("lookUp", lookUp);
			} else {
				so.setProperty("lookUp", [1]);
			}
			so.setDirty("lookUp");
			if (so.data["list_"+whichList] == undefined) {				
				lastList = actingList = [myID];
				so.setProperty("list_"+whichList, actingList);
				so.setDirty("list_"+whichList);
			} else {
				actingList = so.data["list_"+whichList];				
				myActingNum = actingList.indexOf(myID);
				if (myActingNum == -1) {					
					if (myFill) {
						var mySpot2:Number = actingList.indexOf(null);
						if (mySpot2 == -1) {
							actingList.push(myID);			
						} else {
							actingList[mySpot2] = myID;
						}		
					} else {
						actingList.push(myID);
					}			
					so.setProperty("list_"+whichList, actingList);
					so.setDirty("list_"+whichList);
					myActingNum = actingList.indexOf(myID);
				} 
				lastList = actingList;
			}		
			dispatchEvent(new Event(Event.CONNECT));
			so.addEventListener(SyncEvent.SYNC,syncHandler);
			
		}
		
		private function syncHandler(event:SyncEvent):void {
						
			if (so.data["list_"+whichList] != lastList) {
				var a:Object;				
				var myTempObj:Object;				
				for (var i:uint=0; i< so.data["list_"+whichList].length; i++) {						
					if (so.data["list_"+whichList][i] != lastList[i]) {					
						if (so.data["list_"+whichList][i] == null) {				
							myTempObj = so.data["id_"+lastList[i]];	
							for (a in myTempObj) {		
								myTempObj[a] = null;													
							}							
							so.setProperty("id_"+lastList[i], myTempObj);								
							dispatchEvent(new Event(Event.REMOVED));
						} else {							
							dispatchEvent(new Event(Event.ADDED));							
						}
					}
				}							
				actingList = lastList = so.data["list_"+whichList];				
			}			
			
			var temp:Object = theirData;
			for (a in temp) {
				if (temp[a] != lastTheirData[a]) {					
					dispatchEvent(new Event(Event.CHANGE));
					lastTheirData = temp;
					break;
				}
			}
			
			//myMessage.appendText("idList " + so.data.idList+"\n");
			//myMessage.appendText("actingList " + actingList+"\n");
			
		}		
		
		public function get theirData() {
			var myObj:Object = new Object();
			var myTempObj:Object;
			var a:Object;
			for (var i:uint=0; i< so.data["list_"+whichList].length; i++) {
				if (i != myActingNum) {	
					myTempObj = so.data["id_"+so.data["list_"+whichList][i]];					
					for (a in myTempObj) {
						if (!myObj[a]) {
							myObj[a] = [];
						} 
						myObj[a].push(myTempObj[a]);						
					}					
				}
			}			
			return myObj;
		}
		
		public function get myData() {			
			return so.data["id_"+myID];			
		}
		
		public function setProperty(p:String, v:Object) {
			var myObject:Object = so.data["id_"+myID];
			myObject[p] = v;
			so.setProperty("id_"+myID, myObject);
			so.setDirty("id_"+myID);
		}				
		
		 private function onReply(result:Object):void {
				trace("onReply received value: " + result);
		 }		
		
	}
}